org.eclipse.viatra.query.runtime.localsearch.operations.extend

## Class ExtendToEStructuralFeatureSource

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendOperation<org.eclipse.emf.ecore.EObject>
  - - org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendToEStructuralFeatureSource

- All Implemented Interfaces:
    IIteratingSearchOperation, ISearchOperation

      public class ExtendToEStructuralFeatureSource
      extends ExtendOperation<org.eclipse.emf.ecore.EObject>
      implements IIteratingSearchOperation

  Iterates over all sources of `EStructuralFeature` using an `VIATRA Base indexer`. It is assumed that the indexer is initialized for the selected `EStructuralFeature`.

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendOperation

      `it, position`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtendToEStructuralFeatureSource(int sourcePosition, int targetPosition, org.eclipse.emf.ecore.EStructuralFeature feature)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.eclipse.emf.ecore.EStructuralFeature` | `getFeature()`
    `IInputKey` | `getIteratedInputKey()` Get the `IInputKey` which instances this operation iterates upon.
    `java.util.List<java.lang.Integer>` | `getVariablePositions()`
    `void` | `onInitialize(MatchingFrame frame, ISearchContext context)` During the execution of the corresponding plan, the onInitialize callback is evaluated before the execution of the operation may begin.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendOperation

      `execute, onBacktrack`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.localsearch.operations.ISearchOperation

      `execute, onBacktrack`

- - ### Constructor Detail

    - #### ExtendToEStructuralFeatureSource

          public ExtendToEStructuralFeatureSource(int sourcePosition,
                                                  int targetPosition,
                                                  org.eclipse.emf.ecore.EStructuralFeature feature)

  - ### Method Detail

    - #### getFeature

          public org.eclipse.emf.ecore.EStructuralFeature getFeature()

    - #### onInitialize

          public void onInitialize(MatchingFrame frame,
                                   ISearchContext context)

      Description copied from interface: `ISearchOperation`
      During the execution of the corresponding plan, the onInitialize callback is evaluated before the execution of the operation may begin. Operations may use this method to initialize its internal data structures.
      Specified by:
        `onInitialize` in interface `ISearchOperation`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getVariablePositions

          public java.util.List<java.lang.Integer> getVariablePositions()

      Specified by:
        `getVariablePositions` in interface `ISearchOperation`
      Returns:
        the ordered list of the variable numbers that are affected by the search operation

    - #### getIteratedInputKey

          public IInputKey getIteratedInputKey()

      Description copied from interface: `IIteratingSearchOperation`
      Get the `IInputKey` which instances this operation iterates upon.
      Specified by:
        `getIteratedInputKey` in interface `IIteratingSearchOperation`
      Since:
        1.4